uses
  Math;

//type single = double;
var
  f: TextFile;
  i, N, M, res, s0, s1, s2, s3: Integer;
  a1, b1, c1, a2, b2, c2, det: Single;
  x, y: array of Single;
begin
  AssignFile(f, 'input.txt'); Reset(f);
  Read(f, N);
  SetLength(x, N + 1);
  SetLength(y, N + 1);
  for i := 1 to N do Read(f, x[i], y[i]);
  Read(f, M);
  SetLength(x, N + M + 1);
  SetLength(y, N + M + 1);
  res := 0;
  for i := 1 to M do begin
    Read(f, s0, s1, s2, s3);
    Assert(MaxIntValue([s0, s1, s2, s3]) < N + i);
    a1 := y[s1] - y[s0]; b1 := x[s0] - x[s1]; c1 := -(a1*x[s1] + b1*y[s1]);
    a2 := y[s3] - y[s2]; b2 := x[s2] - x[s3]; c2 := -(a2*x[s3] + b2*y[s3]);
    det := a1*b2 - b1*a2;
    Assert(det <> 0.0);
    x[N + i] := (c1*b2 - c2*b1) / det;
    y[N + i] := (a1*c2 - a2*c1) / det;
    if (x[N + i] = 0) and (y[N + i] = 0) then begin
      res := i;
      break;
    end;
  end;
  CloseFile(f);
  AssignFile(f, 'output.txt'); Rewrite(f);
  Write(f, res);
  CloseFile(f);
end.